#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtGui>
#include <QTimer>
#include <QDebug>
#include <aboutwindow.h>
#include <compatibilitywindow.h>
#include <kernelmessageswindow.h>
#include <procwatch.h>
#include <helpwindow.h>
#include <QPainter>
#ifdef Q_WS_MAEMO_5
#include <QMaemo5InformationBox>
#endif

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
public slots:
    void setBackgroundImage(const QString &image);

private:
    Ui::MainWindow *ui;
    void connectSignals();
    QString m_BackgroundImage;
    void paintEvent(QPaintEvent*);

private slots:
    void about();
    void kernelmessages();
    void CL();
    void jailbreakOn();
    void jailbreakOnHermes();
    void jailbreakOff();
    void helpWindow();
    void orientationChanged();
    void selectFirmware(int);
};

#endif // MAINWINDOW_H
