#include "procwatch.h"
#include "mainwindow.h"

procwatch::procwatch(QObject *parent) :
    QObject(parent)
{

}

// Create the timer and start it, public slot.

void procwatch::startTimer()
{
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(detectStatus()));
    timer->start(500);
    qDebug() << "procwatch: QTimer started.";
}

// Stop timer.

void procwatch::stopTimer()
{
    qDebug() << "procwatch: QTimer stopped.";
    timer->stop();
}

// Read /proc file, currently borked.

void procwatch::detectStatus()
{
    QFile file("/proc/psfreedom/status");
    file.open(QIODevice::ReadOnly | QIODevice::Text);
    QTextStream in(&file);
    QString line = in.readLine();
//        qDebug() << line;
        if (line == "INIT") {
//            qDebug() << "/proc/psfreedom/status reads INIT";
            system("run-standalone.sh dbus-send --system --type=method_call --dest=com.nokia.mce /com/nokia/mce/request com.nokia.mce.request.req_led_pattern_deactivate string:'PatternJailbreakComplete'");
        }
        if (line == "DONE") {
            qDebug() << "procwatch: /proc/psfreedom/status reads DONE, switching LED colour and stopping timer...";
            system("run-standalone.sh dbus-send --system --type=method_call --dest=com.nokia.mce /com/nokia/mce/request com.nokia.mce.request.req_led_pattern_deactivate string:'PatternJailbreakStarted'");
            system("run-standalone.sh dbus-send --system --type=method_call --dest=com.nokia.mce /com/nokia/mce/request com.nokia.mce.request.req_led_pattern_activate string:'PatternJailbreakComplete'");
            procwatch::stopTimer();
        }
}

